"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Breadcrumb = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const faArrowLeft_1 = require("@fortawesome/pro-solid-svg-icons/faArrowLeft");
const faChevronRight_1 = require("@fortawesome/pro-solid-svg-icons/faChevronRight");
const faEllipsis_1 = require("@fortawesome/pro-solid-svg-icons/faEllipsis");
const classNames_1 = require("../../utils/classNames");
// eslint-disable-next-line @typescript-eslint/ban-ts-comment
// @ts-ignore: @carbon/react has no exported member 'Breadcrumb'
const react_1 = require("@carbon/react");
// eslint-disable-next-line @typescript-eslint/ban-ts-comment
// @ts-ignore: @carbon/react has no exported member 'BreadcrumbItem'
const react_2 = require("@carbon/react");
// eslint-disable-next-line @typescript-eslint/ban-ts-comment
// @ts-ignore: @carbon/react has no exported member 'OverflowMenu'
const react_3 = require("@carbon/react");
// eslint-disable-next-line @typescript-eslint/ban-ts-comment
// @ts-ignore: @carbon/react has no exported member 'BreadcrumbItem'
const react_4 = require("@carbon/react");
const Link_1 = require("../Link/Link");
const Breadcrumb = ({ items, className, skeletonLoading = false, dataTestid, id, }) => {
    const classes = (0, classNames_1.classNames)('bas breadcrumb', className);
    const overflowMenuItems = items.length > 4
        ? [
            ...items.filter((item, index) => index > 1 && index < items.length - 1),
        ]
        : [];
    const allItems = items.length > 4
        ? [
            ...items.filter((item, index) => index >= 0 && index <= 1),
            {
                label: '...',
                hasMenu: true,
            },
            items[items.length - 1],
        ]
        : items;
    const itemIcon = (index, itemCount) => {
        if (index === 0) {
            return (0, jsx_runtime_1.jsx)("span", { className: "pipe", children: "|" });
        }
        if (index < itemCount - 1) {
            return (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faChevronRight_1.faChevronRight });
        }
        return null;
    };
    const breadcrumbOverflowMenu = () => {
        return ((0, jsx_runtime_1.jsx)(react_3.OverflowMenu, { className: "breadcrumb-overflow", renderIcon: () => (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faEllipsis_1.faEllipsis }), children: overflowMenuItems.map((item, index) => ((0, jsx_runtime_1.jsx)(react_4.OverflowMenuItem, { itemText: item.label, href: item.link }, `carbon-overflow-menu-item${index}`))) }));
    };
    const breadcrumbLink = (index, itemCount, item) => {
        if (skeletonLoading) {
            return ((0, jsx_runtime_1.jsx)(Link_1.Link, { skeletonLoading: skeletonLoading, skeletonLoadingWidth: "100px", className: "breadcrumb-link" }));
        }
        if (item.hasMenu) {
            return breadcrumbOverflowMenu();
        }
        if (index < itemCount - 1) {
            return (0, jsx_runtime_1.jsx)(Link_1.Link, { href: item.link, children: item.label });
        }
        return (0, jsx_runtime_1.jsx)("span", { children: item.label });
    };
    return ((0, jsx_runtime_1.jsx)(react_1.Breadcrumb, { className: classes, noTrailingSlash: true, "data-testid": dataTestid, id: id, children: allItems.map((item, index) => ((0, jsx_runtime_1.jsx)(react_2.BreadcrumbItem, { className: "breadcrumb-item", children: (0, jsx_runtime_1.jsxs)("span", { className: "breadcrumb-item-wrapper", children: [index === 0 && (0, jsx_runtime_1.jsx)(Link_1.Link, { icon: faArrowLeft_1.faArrowLeft, href: item.link }), breadcrumbLink(index, allItems.length, item), itemIcon(index, allItems.length)] }, `breadcrumb-item-${index}`) }, `carbon-breadcrumb-item-${index}`))) }));
};
exports.Breadcrumb = Breadcrumb;
//# sourceMappingURL=Breadcrumb.js.map