"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Button = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const classNames_1 = require("../../utils/classNames");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const faSpinnerThird_1 = require("@fortawesome/pro-solid-svg-icons/faSpinnerThird");
const react_1 = require("@carbon/react");
const Button = ({ label, color = 'primary', type = 'filled', size, borderRadius = 'minimal', iconPosition = 'left', disabled = false, loading = false, icon: IconComponent, className, children, id, dataTestId, skeletonLoading = false, onClick, }) => {
    const classes = (0, classNames_1.classNames)('bas button', loading && 'loading', !!IconComponent && `icon-${iconPosition || 'left'}`, className, color, type, 'border-radius-' + borderRadius, 'size-' + size, !label && !children && 'no-text');
    const getButtonKind = () => {
        if ((color === 'primary' || color === 'secondary') &&
            (type === 'outlined' || type === 'ghost')) {
            return 'tertiary';
        }
        else if (color === 'primary' && type === 'ghost') {
            return 'ghost';
        }
        return color;
    };
    const skeleton = ((0, jsx_runtime_1.jsx)(react_1.ButtonSkeleton, { className: `bas button button-skeleton size-${size}` }));
    const button = ((0, jsx_runtime_1.jsxs)(react_1.Button, { onClick: onClick, "data-testid": dataTestId, id: id, className: classes, disabled: disabled, kind: getButtonKind(), children: [(0, jsx_runtime_1.jsx)("div", { className: "loader-wrapper", id: "loader-wrapper", children: (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: faSpinnerThird_1.faSpinnerThird, className: "loader fa-spin" }) }), (0, jsx_runtime_1.jsxs)("span", { className: "content", children: [iconPosition === 'left' && IconComponent, label || children, iconPosition === 'right' && IconComponent] })] }));
    return skeletonLoading ? skeleton : button;
};
exports.Button = Button;
//# sourceMappingURL=Button.js.map