"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Dropdown = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("@carbon/react");
// eslint-disable-next-line @typescript-eslint/ban-ts-comment
// @ts-ignore: @carbon/react has no exported member 'MultiSelect'
const react_2 = require("@carbon/react");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const pro_solid_svg_icons_1 = require("@fortawesome/pro-solid-svg-icons");
const classNames_1 = require("../../utils/classNames");
const Dropdown = ({ className, dataTestid, id = '', label, items, initialSelectedItem, helperText, titleText, onChange, invalid, invalidText, skeletonLoading, disabled, multiSelect = false, }) => {
    const classes = (0, classNames_1.classNames)(className);
    const iconSwitcher = () => {
        let customStyle;
        if (titleText && titleText.length > 0)
            customStyle = 'extra';
        return ((0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { className: (0, classNames_1.classNames)('invalid-icon', customStyle), size: "sm", icon: pro_solid_svg_icons_1.faCircleExclamation }));
    };
    const dropdownSwitcher = () => {
        if (multiSelect) {
            return ((0, jsx_runtime_1.jsx)(react_2.MultiSelect, { disabled: disabled, id: id, "data-testid": dataTestid, className: classes, onChange: onChange, helperText: helperText, titleText: titleText, items: items, label: label, itemToString: (item) => (item ? item.text : ''), initialSelectedItems: initialSelectedItem, invalid: invalid, invalidText: invalidText }));
        }
        return ((0, jsx_runtime_1.jsx)(react_1.Dropdown, { disabled: disabled, id: id, "data-testid": dataTestid, className: classes, onChange: onChange, helperText: helperText, titleText: titleText, items: items, label: label, itemToString: (item) => (item ? item.text : ''), initialSelectedItem: initialSelectedItem, invalid: invalid, invalidText: invalidText }));
    };
    if (skeletonLoading)
        return (0, jsx_runtime_1.jsx)(react_1.DropdownSkeleton, {});
    return ((0, jsx_runtime_1.jsxs)("div", { className: "bas dropdown", children: [invalid && iconSwitcher(), dropdownSwitcher()] }));
};
exports.Dropdown = Dropdown;
//# sourceMappingURL=Dropdown.js.map