"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileUploader = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("react");
const react_2 = require("@carbon/react");
// eslint-disable-next-line @typescript-eslint/ban-ts-comment
// @ts-ignore: @carbon/react has no exported member 'SkeletonPlaceholder'
const react_3 = require("@carbon/react");
// eslint-disable-next-line @typescript-eslint/ban-ts-comment
// @ts-ignore: @carbon/react has no exported member 'SkeletonText'
const react_4 = require("@carbon/react");
const classNames_1 = require("../../utils/classNames");
const pro_regular_svg_icons_1 = require("@fortawesome/pro-regular-svg-icons");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const FileUploader = ({ labelText, labelDescription, buttonLabel, buttonKind, size, filenameStatus, accept, multiple, disabled, iconDescription, name, className, isDragandDrop, id, onClick, pattern, DragAndDropTitle, skeletonLoading, invalid, errorSubject, errorBody, dataTestid, imageUploaderBox, }) => {
    const classes = (0, classNames_1.classNames)('bas fileUploader', className, disabled && 'disabled', isDragandDrop && 'dragAndDropUploader', imageUploaderBox && 'dragAndDropImageBox');
    const dropContainerRef = (0, react_1.useRef)(null);
    const [file, setFile] = (0, react_1.useState)([]);
    const handleDelete = (fileToDelete) => {
        const updatedFiles = file.filter((file) => file !== fileToDelete);
        // Update the state with the new array
        setFile(updatedFiles);
    };
    const handleAddFiles = (_event, files) => {
        if (files && files.addedFiles) {
            const addedFiles = files.addedFiles;
            if (addedFiles && addedFiles.length) {
                setFile([...file, ...addedFiles]);
            }
        }
    };
    if (skeletonLoading) {
        return ((0, jsx_runtime_1.jsxs)("div", { className: "fileuploaderSkeleton", children: [(0, jsx_runtime_1.jsx)(react_4.SkeletonText, {}), (0, jsx_runtime_1.jsx)(react_4.SkeletonText, {}), (0, jsx_runtime_1.jsx)(react_3.SkeletonPlaceholder, {})] }));
    }
    if (isDragandDrop) {
        return ((0, jsx_runtime_1.jsxs)("div", { className: classes, children: [(0, jsx_runtime_1.jsx)("p", { className: "cds--file--label", children: DragAndDropTitle }), (0, jsx_runtime_1.jsx)("p", { className: "cds--label-description", children: labelDescription }), imageUploaderBox ? ((0, jsx_runtime_1.jsxs)("div", { className: "dragDropWrapper", children: [(0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { className: "cameraPlusIcon", size: "lg", icon: pro_regular_svg_icons_1.faCamera }), (0, jsx_runtime_1.jsx)(react_2.FileUploaderDropContainer, { id: id, innerRef: dropContainerRef, labelText: labelText, onClick: onClick, onAddFiles: handleAddFiles, pattern: pattern, accept: accept, multiple: multiple, disabled: disabled, name: name, className: "file-uploader-drop-component", "data-testid": dataTestid })] })) : ((0, jsx_runtime_1.jsxs)("div", { className: "dragDropWrapper", children: [(0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { className: "filePlusIcon", size: "lg", icon: pro_regular_svg_icons_1.faFilePlus }), (0, jsx_runtime_1.jsx)(react_2.FileUploaderDropContainer, { id: id, innerRef: dropContainerRef, labelText: labelText, onClick: onClick, onAddFiles: handleAddFiles, pattern: pattern, accept: accept, multiple: multiple, disabled: disabled, name: name, className: "file-uploader-drop-component", "data-testid": dataTestid }), (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { className: "upLineIcon", size: "lg", icon: pro_regular_svg_icons_1.faArrowUpFromLine })] })), file.map((file, index) => ((0, jsx_runtime_1.jsx)(react_2.FileUploaderItem, { name: file.name, status: filenameStatus, onDelete: () => handleDelete(file), uuid: "fileuploaderItem", iconDescription: iconDescription, invalid: invalid, errorSubject: errorSubject, errorBody: errorBody, size: size }, index)))] }));
    }
    return ((0, jsx_runtime_1.jsx)("div", { className: classes, children: (0, jsx_runtime_1.jsx)(react_2.FileUploader, { id: id, labelTitle: labelText, labelDescription: labelDescription, buttonLabel: buttonLabel, buttonKind: buttonKind, size: size, filenameStatus: filenameStatus, accept: accept, multiple: multiple, disabled: disabled, iconDescription: iconDescription, name: name, className: "file-uploader-component", "data-testid": dataTestid }) }));
};
exports.FileUploader = FileUploader;
//# sourceMappingURL=FileUploader.js.map