"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Input = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
// eslint-disable-next-line @typescript-eslint/ban-ts-comment
// @ts-ignore: @carbon/react has no exported member 'MultiSelect'
const react_1 = require("@carbon/react");
const classNames_1 = require("../../utils/classNames");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const pro_solid_svg_icons_1 = require("@fortawesome/pro-solid-svg-icons");
const Input = ({ className, dataTestid, id = '', labelText = '', helperText, type = 'text', placeholder, state, feedbackText, onClick, onChange, disabled, skeletonLoading, }) => {
    const iconSwitcher = () => {
        let customStyle;
        if (labelText.length > 0)
            customStyle = 'extra';
        switch (state) {
            case 'invalid':
                return ((0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { className: (0, classNames_1.classNames)('invalid-icon', customStyle), size: "sm", icon: pro_solid_svg_icons_1.faCircleExclamation }));
            case 'warning':
                return ((0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { className: (0, classNames_1.classNames)('warn-icon', customStyle), size: "sm", icon: pro_solid_svg_icons_1.faExclamationTriangle }));
            case 'valid':
                return ((0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { className: (0, classNames_1.classNames)('valid-icon', customStyle), size: "sm", icon: pro_solid_svg_icons_1.faCheck }));
            default:
                break;
        }
    };
    const classes = (0, classNames_1.classNames)(className);
    if (skeletonLoading)
        return (0, jsx_runtime_1.jsx)(react_1.TextInputSkeleton, {});
    if (type === 'password')
        return ((0, jsx_runtime_1.jsx)("div", { className: "bas input", children: (0, jsx_runtime_1.jsx)(react_1.PasswordInput, { id: id, "data-testid": dataTestid, disabled: disabled, className: classes, labelText: labelText, helperText: helperText, placeholder: placeholder, invalid: state === 'invalid', warn: state === 'warning', invalidText: feedbackText, warnText: feedbackText, onClick: onClick, onChange: onChange }) }));
    return ((0, jsx_runtime_1.jsxs)("div", { className: "bas input", children: [iconSwitcher(), (0, jsx_runtime_1.jsx)(react_1.TextInput, { id: id, "data-testid": dataTestid, disabled: disabled, className: classes, type: type, labelText: labelText, helperText: helperText, placeholder: placeholder, invalid: state === 'invalid', warn: state === 'warning', invalidText: feedbackText, warnText: feedbackText, onClick: onClick, onChange: onChange })] }));
};
exports.Input = Input;
//# sourceMappingURL=Input.js.map