"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Notification = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("react");
const classNames_1 = require("../../utils/classNames");
const react_2 = require("@carbon/react");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const pro_solid_svg_icons_1 = require("@fortawesome/pro-solid-svg-icons");
const Notification = ({ showIcon = true, hideCloseButton = false, kind, onClose, title = '', subtitle, id, dataTestid, className, }) => {
    const [hideNotification, setHideNotification] = (0, react_1.useState)(false);
    const classes = (0, classNames_1.classNames)('bas notification', className, kind);
    const iconSwitcher = () => {
        if (!showIcon) {
            return '';
        }
        switch (kind) {
            case 'info':
                return (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: pro_solid_svg_icons_1.faInfoCircle, className: "main-icon" });
            case 'warning':
                return ((0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: pro_solid_svg_icons_1.faExclamationSquare, className: "main-icon" }));
            case 'error':
                return ((0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: pro_solid_svg_icons_1.faExclamationTriangle, className: "main-icon" }));
            case 'success':
                return (0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: pro_solid_svg_icons_1.faCheckCircle, className: "main-icon" });
            default:
                break;
        }
    };
    if (hideNotification) {
        return null;
    }
    return ((0, jsx_runtime_1.jsxs)("div", { className: classes, children: [iconSwitcher(), (0, jsx_runtime_1.jsx)(react_2.InlineNotification, { id: id, "data-testid": dataTestid, hideCloseButton: hideCloseButton, kind: kind, onClose: onClose, title: title, subtitle: subtitle, lowContrast: true, onCloseButtonClick: () => setHideNotification(true) })] }));
};
exports.Notification = Notification;
//# sourceMappingURL=Notification.js.map