import { DetailedHTMLProps } from 'react';
type HtmlSpanProps = DetailedHTMLProps<React.ButtonHTMLAttributes<HTMLSpanElement>, HTMLSpanElement>;
type offsetProps = {
    top: number;
    left: number;
};
type offsetFuncArgs = {
    menuBody: HTMLElement;
    direction: 'DIRECTION_TOP' | 'DIRECTION_BOTTOM';
    trigger: HTMLElement;
    flip: boolean;
};
type offsetFunc = ({ menuBody, direction, trigger, flip, }: offsetFuncArgs) => offsetProps;
interface OverflowMenuProps extends HtmlSpanProps {
    children: React.ReactNode;
    flipped?: boolean;
    dataTestid?: string;
    focusTrap?: boolean;
    iconClass?: string;
    iconDescription?: string;
    menuOffset?: offsetProps | offsetFunc;
    menuOffsetFlip?: offsetProps | offsetFunc;
    direction?: 'top' | 'bottom';
    menuOptionsClass?: string;
    onClose?: () => void;
    onOpen?: () => void;
    open: boolean;
    selectorPrimaryFocus?: string;
    disabled?: boolean;
    size?: 'small' | 'regular';
}
declare const OverflowMenu: ({ children, flipped, focusTrap, iconDescription, iconClass, direction, menuOptionsClass, onClick, onClose, onFocus, onKeyDown, onOpen, open, selectorPrimaryFocus, disabled, className, menuOffset, menuOffsetFlip, size, }: OverflowMenuProps) => import("react/jsx-runtime").JSX.Element;
export default OverflowMenu;
