"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.calculatePopupPosition = void 0;
function calculatePopupPosition(ref) {
    const rect = ref.getBoundingClientRect();
    const viewportWidth = window.innerWidth;
    const viewportHeight = window.innerHeight;
    // Calculate available space on each side
    const spaceTop = rect.top;
    const spaceBottom = viewportHeight - rect.bottom;
    const spaceLeft = rect.left;
    const spaceRight = viewportWidth - rect.right;
    // Determine which side has the most space
    let position = 'top';
    let maxSpace = spaceTop;
    if (spaceBottom > maxSpace) {
        position = 'bottom';
        maxSpace = spaceBottom;
    }
    if (spaceLeft > maxSpace) {
        position = 'left';
        maxSpace = spaceLeft;
    }
    if (spaceRight > maxSpace) {
        position = 'right';
    }
    return position;
}
exports.calculatePopupPosition = calculatePopupPosition;
exports.default = calculatePopupPosition;
//# sourceMappingURL=calculate-popup-position.js.map