"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Toast = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const classNames_1 = require("../../utils/classNames");
const react_1 = require("@carbon/react");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const pro_solid_svg_icons_1 = require("@fortawesome/pro-solid-svg-icons");
// eslint-disable-next-line @typescript-eslint/ban-ts-comment
// @ts-ignore: @carbon/react has no exported member 'skeletonPlaceholder'
const react_2 = require("@carbon/react");
const Toast = ({ skeletonLoading, kind, onClose, title, skeletonLoadingWidth, dataTestid, id, className, }) => {
    const classes = (0, classNames_1.classNames)('bas toast', kind, className);
    const iconSwitcher = () => {
        switch (kind) {
            case 'warning':
                return ((0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: pro_solid_svg_icons_1.faExclamationSquare, className: "main-icon faWarningToast" }));
            case 'error':
                return ((0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: pro_solid_svg_icons_1.faExclamationTriangle, className: "main-icon faErrorToast" }));
            case 'success':
                return ((0, jsx_runtime_1.jsx)(react_fontawesome_1.FontAwesomeIcon, { icon: pro_solid_svg_icons_1.faCheckCircle, className: "main-icon faSuccessToast" }));
            default:
                break;
        }
    };
    if (skeletonLoading) {
        return ((0, jsx_runtime_1.jsx)(react_2.SkeletonText, { width: skeletonLoadingWidth, className: "skeletonLoadingToast" }));
    }
    return ((0, jsx_runtime_1.jsxs)("div", { className: classes, children: [(0, jsx_runtime_1.jsx)(react_1.ToastNotification, { "aria-label": "closes notification", onClose: onClose, lowContrast: true, kind: kind, title: title, "data-testid": dataTestid, id: id, children: iconSwitcher() }), (0, jsx_runtime_1.jsx)("div", { className: "progressBar" })] }));
};
exports.Toast = Toast;
//# sourceMappingURL=Toast.js.map